TABLES ;TABLES/ASM
 FHL	INC	L		;bump HL up to 3FFH
 	RET	NZ		;not at page boundary
 	INC	H		;bump page
 	BIT	2,H
 	RET	Z
 	LD	H,0
 	RET
 BHL	DEC	HL		;reduce HL till <0
 	BIT	7,H		;return if >=0
 	RET	Z
 	LD	H,3		;else set at 3FFH
 	RET
 DOTABLE1	LD	DE,TABLE1	;point to table
 	LD	IX,OLAY+896	;point to overlay area
 	LD	BC,4002H	;64 x 2 iterations
 	LD	HL,(SHIPH)	;ship horizontal
 LP2	PUSH	HL		;save counter
 	ADD	HL,DE		;point to table byte
 	LD	A,(HL)		;get it
 	AND	0C0H		;IX displacement
 	LD	(INS1+2),A	;put into instruction
 	LD	A,(HL)		;get again
 	POP	HL		;restore counter
 	AND	7		;low 3 bits only
 	BIT	0,C		;which side of byte
 	JR	Z,LP3
 	INC	A		;align to right side byte
 LP3	SLA	A
 	SLA	A
 	SLA	A		;align for instruction
 	OR	0C6H		;have it
 	LD	(INS1+3),A	;put into instruction
 INS1	DB	0DDH
 	DB	0CBH		;set b,(ix+d) opcode
 	DB	0
 	DB	0
 	CALL	FHL		;move hl foreward
 	DEC	C		;less counter
 	JR	NZ,LP2
 	LD	C,2
 	INC	IX
 	DJNZ	LP2		;do whole line
 	RET			;done with ground
 PUTGROUND
 	LD	HL,OLAY+128
 	LD	DE,OLAY+129
 	LD	BC,63
 	LD	(HL),176
 	LDIR
 	LD	A,149		;divide lr/sr scanner
 	LD	(OLAY+64+26),A
 	LD	A,181
 	LD	(OLAY+128+26),A
 	LD	A,170
 	LD	(OLAY+64+36),A
 	LD	A,186
 	LD	(OLAY+128+36),A
 	LD	HL,(SHIPR)	;get ship relative
 	LD	B,3		;divide x 8
 LPPP1	CALL	DIVID		;divide x2
 	DJNZ	LPPP1
 	LD	A,L
 	AND	0FH
 	ADD	A,54
 	LD	E,A		;pass to POINT
 	INC	E
 	LD	A,(SHIPV)	;get vertical
 	RRCA
 	RRCA
 	RRCA
 	AND	0FH
 	INC	A
 	INC	A
 	LD	D,A
 	JP	SET
 FHLX	INC	L		;bump HL up to 40H
 	LD	A,L
 	CP	40H
 	RET	C
 	LD	L,0		;else start table over
 	RET
 DIVID	OR	A		;clear carry
 	RR	H		;halve MSB
 	RR	L		;halve LSB, with carry
 	RET			;done
 BHLX	DEC	L
 	RET	P
 	LD	L,3FH
 	RET
 TITLE	LD	HL,NAME		;name string
 	LD	DE,OLAY+27
 	LD	BC,9
 	LDIR
 	RET
 SCORE	LD	HL,SCORE1	;player one
 	LD	DE,OLAY+0
 	LD	BC,7
 	PUSH	BC
 	LDIR
 	POP	BC
 	LD	A,(PLAYERS)
 	CP	1
 	RET	Z
 	LD	HL,SCORE2	;player two
 	LD	DE,OLAY+57
 	LDIR
 	RET
 DOMEN
 	LD	IY,TABLEM	;table of men locations
 	LD	B,10		;10 maximum
 PUTMENLP	LD	A,(IY)	;get stage byte
 	OR	A		;active ?
 	PUSH	BC
 	CALL	NZ,PUTMAN	;insert the guy
 	POP	BC
 	INC	IY
 	INC	IY
 	INC	IY
 	INC	IY
 	DJNZ	PUTMENLP
 	RET
 PUTMAN	LD	L,(IY+1)
 	LD	H,(IY+2)
 	LD	DE,(SHIPH)	;get big screen posit
 	OR	A		;clear carry
 	SBC	HL,DE		;compare
 	RET	C
 	DEC	H
 	INC	H
 	RET	NZ
 	LD	A,L
 	CP	128
 	RET	NC
 	LD	E,L
 	LD	D,(IY+3)
 	CALL	TEST
 	LD	(HL),'A'
 	RET
 SETMEN	LD	IY,TABLEM
 	LD	B,10		;10 entries
 SETMLP	LD	(IY),1		;activate
 	LD	A,R
 	LD	H,A
 	LD	L,E
 	LD	D,(HL)
 	LD	A,R
 	LD	L,A
 	XOR	(HL)
 	XOR	H
 	LD	(IY+1),A
 	LD	E,A
 	LD	A,R
 	LD	H,A
 	XOR	D
 	AND	3
 	LD	(IY+2),A
 	LD	D,A
 	LD	HL,TABLE1
 	ADD	HL,DE
 	LD	A,(HL)
 	AND	0C0H
 	JR	Z,NEXPUT
 	BIT	7,A
 	JR	NZ,NEXPUTX
 	LD	(IY+3),46
 	JR	NEXMAN
 NEXPUT	LD	(IY+3),43
 	JR	NEXMAN
 NEXPUTX	LD	(IY+3),40
 NEXMAN	INC	IY
 	INC	IY
 	INC	IY
 	INC	IY
 	DJNZ	SETMLP
 	RET
 DOCREATURES
 	LD	IY,TABLEC	;creature table
 	LD	B,30		;allow 30 max
 PUTCRELP	LD	A,(IY)	;get stage byte
 	OR	A
 	PUSH	BC
 	CALL	NZ,PUTCRE
 	LD	BC,9
 	ADD	IY,BC
 	POP	BC
 	DJNZ	PUTCRELP
 	RET
 PUTCRE	CALL	SETCRE		;set IX to type
 	LD	L,(IY+2)
 	LD	H,(IY+3)
 	LD	(IY+7),0
 	LD	(IY+8),0
 	LD	DE,(SHIPH)
 	OR	A
 	SBC	HL,DE
 	JR	C,DOUBCHK
 	DEC	H
 	INC	H
 	RET	NZ
 	LD	A,L
 	CP	128
 	RET	NC
 DOUBRET	LD	H,(IY+1)
 	LD	(IY+7),L
 	LD	(IY+8),H
 	BIT	7,(IY)
 	JP	Z,DRAWIT
 	JP	DRAWONE
 DOUBCHK	LD	HL,896
 	OR	A
 	SBC	HL,DE
 	RET	NC
 	LD	HL,1024
 	OR	A
 	SBC	HL,DE		;compute difference
 	LD	E,L		;save result
 	LD	A,128
 	SUB	E
 	LD	D,A
 	LD	A,(IY+3)
 	OR	A
 	RET	NZ
 	LD	A,(IY+2)
 	CP	D		;past result ?
 	RET	NC
 	ADD	A,E		;add to lsb
 	LD	L,A		;pass here
 	JR	DOUBRET
 MOVECRE	LD	B,30
 	LD	IY,TABLEC
 MOVECREL	LD	A,(IY)
 	OR	A
 	PUSH	BC
 	CALL	NZ,MOVCR
 	LD	BC,9
 	ADD	IY,BC
 	POP	BC
 	DJNZ	MOVECREL
 	RET
 MOVCR	LD	A,(CLOCK)	;check the timer
 	AND	(IY+6)		;time to move it?
 	JP	Z,DOSKP		;skip this time
 	LD	B,(IY+5)	;else get horizontal move
 	LD	L,(IY+2)
 	LD	H,(IY+3)
 	BIT	7,B
 	RES	7,B
 	JR	Z,DOF
 DOB	CALL	BHL
 	DJNZ	DOB
 	JR	DOCON
 DOF	CALL	FHL
 	DJNZ	DOF
 DOCON	LD	(IY+2),L
 	LD	(IY+3),H
 	LD	A,(IY+4)	;vertical motion
 	ADD	A,(IY+1)
 	CP	48
 	JR	NC,DOSKPX
 	CP	9
 	JR	C,DOSKPY
 	LD	(IY+1),A
 	JR	DOSKP
 DOSKPY	LD	(IY+1),47
 	JR	DOSKP
 DOSKPX	LD	(IY+1),11
 	BIT	7,(IY+4)
 	JR	Z,DOSKP
 	LD	(IY+1),47
 DOSKP	LD	A,(IY)		;get stage again
 	AND	7FH
 	DEC	A
 	LD	E,A
 	LD	D,0
 	LD	HL,TABLECN	;next creature
 	ADD	HL,DE
 	LD	A,(HL)
 	LD	(IY),A		;set next stage
 	RET
 SETCRE	AND	7FH		;mask last bit
 	DEC	A		;adjust for table
 	SLA	A		;double it
 	LD	E,A
 	LD	D,0
 	LD	HL,TABLECR	;type table
 	ADD	HL,DE
 	LD	E,(HL)
 	INC	HL
 	LD	D,(HL)
 	PUSH	DE
 	POP	IX
 	RET
 DRAWONE	EX	DE,HL
 	PUSH	DE
 	CALL	TEST
 	POP	DE
 	LD	A,(IX)
 	LD	(HL),A
 	EX	DE,HL
 	RET
 DUMPMEN	LD	IX,TABLEC	;look for empty spots
 	LD	BC,1E08H	;B=30 spots, C = saucers
 DUPLP	LD	A,(IX)		;available ?
 	OR	A
 	JR	Z,PUTSAU	;put a saucer here
 DUPRT	LD	DE,9
 	ADD	IX,DE
 	DJNZ	DUPLP
 DUMPRT	LD	A,6
 	JP	DUMPMENX	;go back for score
 PUTSAU	LD	(IX),88H	;set up a saucer
 	LD	A,(IY+1)
 	LD	(IX+1),A	;pass location
 	LD	A,(IY+2)
 	LD	(IX+2),A
 	LD	A,(IY+3)
 	LD	(IX+3),A
 	CALL	RANV		;random vertical
 	LD	(IX+4),A
 	CALL	RANH		;random horizontal
 	LD	(IX+5),A
 	LD	(IX+6),0FFH	;make it quick
 	LD	(IX+7),0
 	LD	(IX+8),0
 	DEC	C
 	JP	Z,DUMPRT
 	JP	DUPRT
 SCOREIT	LD	A,(IY)		;get type of man hit
 	AND	7FH		;remove hit bit
 	CP	6		;special cases
 	JR	Z,DUMPMEN	;dump saucers
 	CP	7
 	JR	Z,DUMPMEN	;either one
 DUMPMENX	DEC	A	;adjust to table
 	LD	C,A
 	LD	B,0
 	LD	HL,TABLECS	;score table
 	ADD	HL,BC
 	LD	B,(HL)		;get score
 	LD	A,(PLAYER)	;which player
 	OR	A
 	LD	HL,SCORE1+5
 	JR	Z,KSCORE
 	LD	HL,SCORE2+5
 KSCORE	PUSH	HL		;save pointer
 	CALL	BUMPSC		;bump the score
 	POP	HL
 	DJNZ	KSCORE
 	RET
 BUMPSC	INC	(HL)		;bump it
 	LD	A,(HL)
 	CP	3AH
 	RET	C
 	LD	(HL),'0'
 	DEC	HL
 	JR	BUMPSC
 RANV	LD	A,R
 	LD	H,A
 	XOR	D
 	LD	L,A
 	LD	A,(HL)
 	CP	127
 	JR	C,RANV1
 	AND	3
 	RET	NZ
 	LD	A,1
 	RET
 RANV1	AND	3
 	JR	NZ,RANV2
 	LD	A,1
 RANV2	NEG
 	RET
 RANH	LD	A,R
 	LD	L,A
 	LD	A,D
 	XOR	H
 	LD	H,A
 	LD	A,(HL)
 	CP	127
 	JR	C,RANH1
 	AND	7
 	RET	NZ
 	LD	A,1
 	RET
 RANH1	AND	7
 	JR	NZ,RANH2
 	LD	A,1
 RANH2	OR	80H
 	RET
 RANH	LD	A,R
 	LD	L,A
 	LD	A,D
 	XOR	H
 	LD	H,A
 	LD	A,(HL)
 	CP	12